
$all      = 1;

$prep     = 0;
$featExt  = 0;
$train    = 0;
$eval_is  = 0;    # selftest with initial models (optional)
$eval_s   = 0;    # selftest with models after HRest-training
$eval_t   = 0;
$train_e  = 0;
$eval_et  = 0;

#############################################################################
# copy files into work directory
-e "hmmconsts.pm" || system( "copy skripte\\hmmconsts.pm . ");
-e "fbview.pl" || system( "copy skripte\\fbview.pl . ");


#############################################################################
# preparing wordlist, dictionary, network
# feature extraction
if( $prep == 1 || $all == 1 ) {

#############################################################################
# check fbview (required)
  $check = system( "fbview.pl -version" );
  print "*****************************************\n";
  print "Checking fbview ... \n";
  if( $check == 0 ) {
    print "OKAY\n";
  } else {
    print "fbview not found!\n";
    print "Please check file fbview.pl (copied from directory scripte)\n";
    exit;
  }

  system( "mkdir logs" ); 
  $confDir ="arbeit\\htkfiles\\confs";
  $listDir ="arbeit\\lists";

  system( "skripte\\prep_dict.pl sprachdaten\\userdata.mlf" );
  system( "skripte\\makedirs.pl" );
  system( "skripte\\gen_gram.pl" );
  system( "skripte\\gen_scp.pl sprachdaten\\userdata.mlf" );
  system( "skripte\\gen_hcopy_list.pl $listDir\\userdata.scp > $listDir\\hcopy.scp");

  system( "skripte\\split_scp.pl" );
  system( "skripte\\prep_recmlf.pl" );

  system( "skripte\\gen_more_scp.pl" );

  $cmd = "fbview.pl -N arbeit\\htkfiles\\networks\\netzwerk -I sprachdaten\\autosave.mlf -cover arbeit\\lists\\autosave.scp";
  print "$cmd\n";
  system( $cmd );

  $cmd = "fbview.pl -N arbeit\\htkfiles\\networks\\cont.net -I merkmale\\userdata_mfcc.mlf -cover arbeit\\lists\\cont_train_mfcc.scp";
  print "$cmd\n";
  system( $cmd );
}

#############################################################################
if( $featExt == 1  || $all == 1 ) {
  system( "skripte\\do_hcopy.pl" );
}


########################################################
# Define model structure 
# Training with HRest (i. e. one word per utterance)
# 
if( $train == 1  || $all == 1 ) {
  system( "skripte\\mkproto.pl" );
  system( "skripte\\do_init.pl" );
  system( "skripte\\do_hrest.pl" );
}

# Recognition tests
# optional recognition on reference data
# initial models
if( $eval_is == 1 ) {
  system( "skripte\\do_hvite.pl 0" );
}
# final models
if( $eval_s == 1 || $all == 1 ) {
  system( "skripte\\do_hvite.pl" );
}

if( $eval_t == 1 || $all == 1 ) {
  system( "skripte\\do_hvite_test.pl" );
}


########################################################
# Training with HERest (embedded) 
if( $train_e == 1 || $all == 1 ) {
  system( "skripte\\do_herest.pl" );
  $hmmDestDir = "arbeit\\htkfiles\\hmms\\hmm.e1";
  -e $hmmDestDir || mkdir $hmmDestDir;
  system( "copy arbeit\\htkfiles\\hmms\\hmm.e\\newMacros $hmmDestDir\\digicom " );
  system( "skripte\\do_herest_up.pl" );
}


########################################################
if( $eval_et == 1 || $all == 1 ) {
  system( "skripte\\do_hvite_ctest.pl" );
}
