#  Phoneme training
#
#  uses mixup to increase number of mixtures
#

$workDir ="arbeit";
$vocDir   = $workDir . "\\htkfiles\\dicts";
$vocFile  = $vocDir .  "\\vokabular"; 
$dictFile = $vocDir .  "\\vokabular_pho"; 
$hmmListFile = $vocDir .  "\\phoneme";
$confFile = $workDir . "\\htkfiles\\confs\\hinit.cf";

$listDir     = "arbeit\\lists";
$listFile    = "cont_train_mfcc.scp";
$gramDir     = $workDir . "\\htkfiles\\networks";
$netFile     = $gramDir . "\\cont.net";
$resDir      = $workDir . "\\results";
$resMlf      = $resDir  . "\\out_p.mlf";
$hmmMacro    = "phoneme";

$hmmDir1 = $workDir . "\\htkfiles\\hmms\\hmm.p1";

$herestOpts = " -T 0 -v 0.01 ";
$hviteOpts  = " -T 1 ";
$newMacro   = $hmmMacro;
$maxMix     = 4;           
$maxIter    = 21;         # Iterations after mixup

for( $mixup=2; $mixup<=$maxMix; ++$mixup ) {

  $cmdup= "HERest $herestOpts -C $confFile -S $listDir\\$listFile  -s statistik.dat -H $hmmDir1\\$newMacro   -I merkmale\\userdata_mfcc_pho.mlf $hmmListFile";
  print "$cmd\n";
  
  for($iter=0; $iter<$maxIter; ++$iter) {
    print "Iteration $iter\n";
    system( $cmdup );
    
    #################################################
    # Recognition on references
    #################################################
    if( $iter % 5 == 0 ) {
      $cmdr ="HVite $hviteOpts -S  $listDir\\$listFile -w $netFile -H $hmmDir1\\$newMacro  -i $resMlf -C $confFile  $dictFile  $hmmListFile";
      
      print "$cmdr\n";
      system( $cmdr );
      
      $cmdr="HResults  -k \"*userdata/%%%*\" -I merkmale\\userdata.mlf $vocFile $resMlf ";
      print "$cmdr\n";
      system( $cmdr );
      if( $iter < 10 ) {
	$resFile = "$resDir\\result_phonem_0$iter";
      } else {
	$resFile = "$resDir\\result_phonem_$iter";
      }
      $resFile += "_$mixup";
      system( $cmdr . "> $resFile" );
    }
  }

  #################################################
  # Perform Mixup to create new HMMs
  #################################################
  if( $mixup < $maxMix  ) {
    $oldMacro = $newMacro;
    $newMacro = "$hmmMacro\_$mixup";
    $cmdr ="HHEd -H  $hmmDir1\\$oldMacro -w  $hmmDir1\\$newMacro  arbeit\\htkfiles\\hhed\\mixup.hhed  $hmmListFile";
    
    print "$cmdr\n";
    system( $cmdr );
  }
}

