#
# Erkennung
#
#
if( $#ARGV == 0 ) {
    $index = $ARGV[0];
    print "Working with specified index $index\n";

}else{
    $index = "1";
    print "Working with default index $index\n";
}



$workDir     = "arbeit";
$confFile    = $workDir . "\\htkfiles\\confs\\hvite_live.cf";
$listDir     = $workDir . "\\lists";
$vocDir      = $workDir . "\\htkfiles\\dicts";
$vocFile     = $vocDir  . "\\vokabular"; 
$hmmlistFile = $vocDir  . "\\hmmlist";
$gramDir     = $workDir . "\\htkfiles\\networks";
$netFile     = $gramDir . "\\net_c";
$hmmDir = $workDir . "\\htkfiles\\hmms\\hmm.$index";

print "Creating $confFile\n";
open(OUT, '>' . $confFile)  || die "could not open $confFile";
print OUT " SOURCEKIND     = WAVEFORM \n";
print OUT " SOURCEFORMAT   = WAVE \n";
print OUT " SOURCERATE     = 625.0\n";
print OUT " MICIN          = TRUE\n";
print OUT " USESILDET      = TRUE\n";
print OUT " MEASURESIL     = FALSE\n";
print OUT " ZMEANSOURCE    = FALSE \n";
print OUT " ENORMALISE     = FALSE \n";
print OUT " TARGETFORMAT   = HTK \n";
print OUT " TARGETKIND     = MFCC_E_D\n";
print OUT " TARGETRATE     = 100000 \n";
print OUT " NUMCHANS       = 21 \n";
print OUT " NUMCEPS        = 12 \n";
print OUT " SAVEWITHCRC    = FALSE \n";
print OUT " WINDOWSIZE     = 200000.0 \n";
print OUT " USEHAMMING     = TRUE \n";
print OUT " PREEMCOEF      = 0.97 \n";
print OUT " LOFREQ         = 330.0 \n";
print OUT " HIFREQ         = 5500.0 \n";
print OUT " CEPLIFTER      = 22 \n";
print OUT " DELTAWINDOW    = 2 \n";
print OUT " USEPOWER       = TRUE \n";
close OUT;



$hviteOpts=" -g -n 2 -z whg -e -T 1 ";

$cmd = "HVite $hviteOpts -w $netFile -d $hmmDir -C $confFile $hmmlistFile $vocFile";
print "$cmd\n";
system( $cmd );


#bin\HVite -g -e -T 1 -w htkfiles\networks\netzwerk -d htkfiles\hmms\hmm.1 -C hvite_live.cf htkfiles\dicts\hmmlist htkfiles\dicts\vokabular
