#
# Erkennung
#
#

use hmmconsts;

if( $#ARGV == 0 ) {
    $index = $ARGV[0];
    print "Working with specified index $index\n";

}else{
    $index = "1";
    print "Working with default index $index\n";
}

$confFile    = $workDir . "\\htkfiles\\confs\\hvite_audio.cf";
$listDir     = $workDir . "\\lists";
$vocDir      = $workDir . "\\htkfiles\\dicts";
$vocFile     = $vocDir  . "\\vokabular"; 
$hmmlistFile = $vocDir  . "\\hmmlist";
$gramDir     = $workDir . "\\htkfiles\\networks";
$netFile     = $gramDir . "\\netzwerk";
# $netFile     = $gramDir . "\\faecher_tag.net";
$listFile    = $listDir . "\\autosave.scp";
$resDir      = $workDir . "\\results";
$resMlf      = $resDir  . "\\rec$index.mlf";
$hmmDir = $workDir . "\\htkfiles\\hmms\\hmm.$index";

system( "mkdir $resDir" );

print "Creating $confFile\n";
open(OUT, '>' . $confFile)  || die "could not open $confFile";
print OUT " SOURCEKIND     = WAVEFORM \n";
print OUT " SOURCEFORMAT   = WAVE \n";
print OUT " SOURCERATE     = 625.0\n";
print OUT " ZMEANSOURCE    = FALSE \n";
print OUT " ENORMALISE     = FALSE \n";
print OUT " TARGETFORMAT   = HTK \n";
print OUT " TARGETKIND     = MFCC_E_D\n";
print OUT " TARGETRATE     = 100000 \n";
print OUT " NUMCHANS       = 21 \n";
print OUT " NUMCEPS        = 12 \n";
print OUT " SAVEWITHCRC    = FALSE \n";
print OUT " WINDOWSIZE     = 200000.0 \n";
print OUT " USEHAMMING     = TRUE \n";
print OUT " PREEMCOEF      = 0.97 \n";
print OUT " LOFREQ         = 330.0 \n";
print OUT " HIFREQ         = 5500.0 \n";
print OUT " CEPLIFTER      = 22 \n";
print OUT " DELTAWINDOW    = 2 \n";
print OUT " USEPOWER       = TRUE \n";
close OUT;

$hviteOpts=" -T 0 ";

$cmd = "HVite $hviteOpts -S $listFile -w $netFile -d $hmmDir -i $resMlf -C $confFile $hmmlistFile $vocFile";

$hmmMacro    = "digicom_2mix";
$hmmDir1 = $workDir . "\\htkfiles\\hmms\\hmm.e1";
# $cmd = "HVite $hviteOpts -S $listFile -w $netFile   -H $hmmDir1\\$hmmMacro -i $resMlf -C $confFile $hmmlistFile $vocFile";

print "$cmd\n";
system( $cmd );

$cmd="HResults  -k \"*autosave/%%%*\" -X \"wav\" -I sprachdaten\\autosave.mlf $vocFile $resMlf ";
print "$cmd\n";
system( $cmd );


print "write results in $resDir\\$resultFileName$index\n";

$cmd="HResults  -k \"*autosave/%%%*\" -p -t -X \"wav\" -I sprachdaten\\autosave.mlf $vocFile $resMlf  ";
system( $cmd . "> $resDir\\$resultFileName$index" );
