$all      = 0;

$prep     = 0;
$init     = 1;     # initialize phoneme models
$train    = 0;
$train_e  = 1;
$eval_et  = 0;

-e "hmmconsts.pm" || system( "copy skripte\\hmmconsts.pm . ");

print "***********************************************\n";
print "*               PHONEME HMMs                  *\n";
print "***********************************************\n";

############################################################################
# preparing wordlist, dictionary, network
if( $prep == 1 || all == 1 ) {
  $mlfFile = "merkmale\\userdata_mfcc_pho.mlf";
  $modelListFile = "arbeit\\htkfiles\\dicts\\phoneme";
  $hledDir = "arbeit\\htkfiles\\hled";
  $hledComFile = "$hledDir\\ex.cmd";
  $dictFile = "arbeit\\htkfiles\\dicts\\vokabular_pho";

  if( !-e $dictFile ) {
    print "Need dictionary:  $dictFile\n";
    exit;
  }

  if( ! -e $hledComFile ) {
     print "Creating HLEd command file \n";
     -e $hledDir || mkdir $hledDir;
     open(OUT, '>' . $hledComFile)  || die "could not open $hledComFile";  
     print OUT "EX\n";
     close OUT;
  }

  $cmd ="HLEd -I merkmale\\userdata_mfcc.mlf -d $dictFile  -n $modelListFile  -S arbeit\\lists\\cont_train_mfcc.scp -i $mlfFile $hledComFile";

  print "$cmd\n";
  system( $cmd ) && die ;

  $cmd = "HLStats -c 10000 $modelListFile $mlfFile";
  print "$cmd\n";
  system( $cmd );
  system( "$cmd > phonem_statistik.dat");


  $cmd = "fbview.pl -N arbeit\\htkfiles\\networks\\cont.net -I merkmale\\userdata_mfcc.mlf -cover arbeit\\lists\\cont_train_mfcc.scp";
  print "$cmd\n";
  system( $cmd );
}

if( $init == 1 || all == 1 ) {
  system( "skripte\\mkproto_phonem.pl" );
  system( "skripte\\do_hcompv.pl" );
}

########################################################
# Training with HERest (embedded) 
if( $train == 1 || all == 1 ) {
  system( "skripte\\do_herest_phonem.pl" );
}

########################################################
$hmmDestDir = "arbeit\\htkfiles\\hmms\\hmm.p1";
-e $hmmDestDir || mkdir $hmmDestDir;
if( 
   ( $train == 1 && $train_e == 1 ) 
   || all == 1 
   || ! -e "$hmmDestDir\\phoneme"
  ) {
  system( "copy arbeit\\htkfiles\\hmms\\hmm.p\\newMacros $hmmDestDir\\phoneme" );
}



########################################################
if( $train_e == 1 || all == 1 ) {
  system( "skripte\\do_herest_up_phonem.pl" );
}


########################################################
if( $eval_et == 1 || all == 1 ) {
  system( "skripte\\do_hvite_ctest_phonem.pl" );
}
